//---------------------------------------------------------------------------
//
//   CopyNames
//
//          Copyright(C) 2015, Tark
//
//     IuWFNgNbv{[hփRs[
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <sstream>
#include "MQPlugin.h"
#include "CMQObject.h"
#include "CopyNames.h"

//---------------------------------------------------------------------------
//  MQGetPlugInID
//---------------------------------------------------------------------------
void CopyNames::GetPlugInID(DWORD *Product, DWORD *ID)
{
	*Product = 0xE3F7A830;
	*ID = 0xBD9A1884;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//---------------------------------------------------------------------------
const char *CopyNames::GetPlugInName(void)
{
	// vOC
	return "CopyNames ver.1.1 Copyright(C) 2015, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//---------------------------------------------------------------------------
const char *CopyNames::EnumString(int index)
{
	switch(index){
	case 0: return "copy ObjectNames"; break;
	case 1: return "restore ObjectNames"; break;
	case 2: return "copy MaterialNames"; break;
	case 3: return "restore MaterialNames"; break;
	}
	return NULL;
}

MQBasePlugin *GetPluginClass()
{
	static CopyNames plugin;
	return &plugin;
}

BOOL CopyNames::Execute(int index, MQDocument doc_)
{
	doc = cmq::CMQDocument(doc_);
	switch (index){
	case 0:
		return copyObjectNamesToClipboard(doc);
	case 1:
		return restoreObjectNamesFromClipboard(doc);
	case 2:
		return copyMaterialNamesToClipboard(doc);
	case 3:
		return restoreMaterialNamesFromClipboard(doc);
	}
	return FALSE;
}

CopyNames::CopyNames() : doc(nullptr)
{
}

CopyNames::~CopyNames()
{
}

// eLXgNbv{[hɃZbg
BOOL setClipboard(const std::string &str)
{
	BOOL result = FALSE;
	if (::OpenClipboard(nullptr)) {
		::EmptyClipboard();
		int bufsize = (str.length() + 1);
		HGLOBAL hg = ::GlobalAlloc(GHND | GMEM_SHARE, bufsize);
		if (hg) {
			char *dest = (char*)::GlobalLock(hg);
			::GlobalUnlock(hg);
			if (dest) {
				strcpy_s(dest, str.length() + 1, str.c_str());
				HANDLE hHandle = ::SetClipboardData(CF_TEXT, hg);
				if (hHandle) {
					OutputDebugString(_T("ok"));
					result = TRUE;
				}
			}
		}
	}
	::CloseClipboard();
	return result;
}

// Nbv{[heLXg擾
BOOL getClipboard(std::string &str)
{
	BOOL result = FALSE;
	if (::OpenClipboard(nullptr)) {
		HANDLE hHandle = ::GetClipboardData(CF_TEXT);
		if (hHandle) {
			OutputDebugString(_T("ok"));
			char *dest = (char*)::GlobalLock(hHandle);
			wchar_t *wdest = (wchar_t*)dest;
			if (dest) {
				str.assign(dest);
				::GlobalUnlock(hHandle);
				result = TRUE;
			}
		}
	}
	::CloseClipboard();
	return TRUE;
}

// IIuWFNgsŘAeLXgNbv{[hփZbg
BOOL CopyNames::copyObjectNamesToClipboard(cmq::CMQDocument &doc)
{
	std::string str;
	std::vector<cmq::oindex_t> objlist = getSelectedObjects(doc);
	for (cmq::oindex_t oindex : objlist) {
		auto obj = doc.getObject(oindex);
		std::string name = obj.getName();
		str += name + "\n";
	}
//	setClipboard(cmq::towstring(str));
	setClipboard(str);
	return TRUE;
}

// sR[hŕ
std::vector<std::string> splitLines(std::string &str)
{
	std::istringstream ist(str);
	std::string name;
	std::vector<std::string> namelist;
	while (std::getline(ist, name)) {
		// sR[hCR+LFꍇCRcĂ̂ō폜
		if (!name.empty() && name.back() == '\r') {
			name.pop_back();
		}
#if UNICODE
		// printable charłȂ̂̓Xy[XœhԂ
		std::wstring wname = cmq::towstring(name);
		for (wchar_t &c : wname) {
			if (!iswprint(c)) {
				c = L' ';
			}
		}
		name = cmq::tostring(wname);
#endif
		namelist.push_back(name);
	}
	return namelist;
}

// w肵ÕIuWFNg
cmq::oindex_t findObject(cmq::CMQDocument &doc, const std::string &name, cmq::oindex_t excpet_oindex)
{
	cmq::oindex_t ocount = doc.getObjectCount();
	for (cmq::oindex_t oindex = 0; oindex < ocount; oindex++) {
		if (oindex == excpet_oindex) {
			continue;
		}
		cmq::CMQObject obj = doc.getObject(oindex);
		if (obj.isLive() && obj.getName() == name) {
			return oindex;
		}
	}
	return -1;
}

// w肵ÕIuWFNg
cmq::mindex_t findMaterial(cmq::CMQDocument &doc, const std::string &name, cmq::mindex_t excpet_mindex)
{
	cmq::mindex_t mcount = doc.getMaterialCount();
	for (cmq::mindex_t mindex = 0; mindex < mcount; mindex++) {
		if (mindex == excpet_mindex) {
			continue;
		}
		MQMaterial mat = doc.getMaterial(mindex);
		if (mat != nullptr && doc.getMaterialName(mat) == name) {
			return mindex;
		}
	}
	return -1;
}

// O̖1₷BȂ1t
std::string incrementNameNumber(std::string &name)
{
	std::string::reverse_iterator it;
	for(it = name.rbegin(); it != name.rend(); it++) {
		if(!isdigit(*it)) {
			break;
		}
	}
	if (it == name.rbegin()) {
		// Ȃ
		name += "1";
		return name;
	}
	else {
		// 
		std::string strnum = name.substr(it.base() - name.begin());
		std::istringstream iss(strnum);
		int no;
		iss >> no;
		no++;
		name.erase(it.base(), name.end());
		std::ostringstream oss(strnum);
		oss << name << no;
		return oss.str();
	}
}

// Nbv{[h擾eLXgsŕāAIIuWFNgɖOƂĐݒ
BOOL CopyNames::restoreObjectNamesFromClipboard(cmq::CMQDocument &doc)
{
	std::string str;
	if (!getClipboard(str)) {
		return FALSE;
	}
	// Nbv{[h擾sŕĖOXgɂ
	std::vector<std::string> namelist = splitLines(str);

	// IIuWFNgXg擾
	std::vector<cmq::oindex_t> objlist = getSelectedObjects(doc);
/*	// [obN邽߂̖OobNAbv
	std::vector<std::string> orignamelist;
	for (int i = 0; i < objlist.size(); i++) {
		auto obj = doc.getObject(objlist[i]);
		auto name = obj.getName();
		orignamelist.push_back(name);
	}
*/
	bool result = TRUE;
	for (int i = 0; i < objlist.size(); i++) {
		if (i >= namelist.size()) {
			// ͂ꂽOXgI
			break;
		}
		auto name = namelist[i];
		if (name.empty()) {
			// w̖O󂾂疳ăXLbv
			continue;
		}
		auto obj = doc.getObject(objlist[i]);
		while (findObject(doc, name, objlist[i]) >= 0) {
			name = incrementNameNumber(name);
		}
		obj.setName(name);
	}

	// ̂܂܂ƕύXOʂɔfȂAIuWFNg̐܂݂𑀍삵Ă݂Ɣf
	// iIuWFNgpl̕\XVNHj
	if (objlist.size() > 0) {
		auto obj = doc.getObject(objlist[0]);
		bool folding = obj.getFolding();
		obj.setFolding(!folding);
		obj.setFolding(folding);
	}
	return result;
}

// IIuWFNgindex̃Xg擾
// IIuWFNg܂肽܂Ăꍇ͂̎qIԂƂ݂ȂĊ܂߂
std::vector<cmq::oindex_t> CopyNames::getSelectedObjects(cmq::CMQDocument &doc)
{
	std::vector<cmq::oindex_t> list;
	cmq::oindex_t ocount = doc.getObjectCount();
	int depth = -1;
	for (cmq::oindex_t oindex = 0; oindex < ocount; oindex++) {
		cmq::CMQObject obj = doc.getObject(oindex);
		if (!obj.isLive()) {
			continue;
		}
		if (depth >= 0) {
			int current_depth = obj.getDepth();
			if (current_depth > depth) {
				// ܂肽܂ꂽqIuWFNgXgɒǉ
				list.push_back(oindex);
				continue;
			}
			else {
				// qIuWFNg甲̂ŁǍ̐eIuWFNgɑ
				depth = -1;
			}
		}
		bool selected = obj.getSelected();
		if (selected) {
			// IIuWFNgXgɒǉ
			list.push_back(oindex);
			if (obj.getFolding()) {
				// IuWFNgłȂ炻ǉΏۂƂ邽߃tO𗧂Ă
				depth = obj.getDepth();
			}
		}
	}
	return list;
}

BOOL CopyNames::copyMaterialNamesToClipboard(cmq::CMQDocument &doc)
{
	std::string str;
	std::vector<cmq::mindex_t> mlist = getSelectedMaterials(doc);
	for (cmq::mindex_t mindex : mlist) {
		auto mat = doc.getMaterial(mindex);
		std::string name = doc.getMaterialName(mat);
		str += name + "\r\n";
	}
//	setClipboard(cmq::towstring(str));
	setClipboard(str);
	return TRUE;
}

BOOL CopyNames::restoreMaterialNamesFromClipboard(cmq::CMQDocument &doc)
{
	std::string str;
	if (!getClipboard(str)) {
		return FALSE;
	}
	// Nbv{[h擾sŕĖOXgɂ
	std::vector<std::string> namelist = splitLines(str);

	// IIuWFNgXg擾
	std::vector<cmq::mindex_t> matlist = getSelectedMaterials(doc);
/*	// [obN邽߂̖OobNAbv
	std::vector<std::string> orignamelist;
	for (int i = 0; i < objlist.size(); i++) {
		auto obj = doc.getObject(objlist[i]);
		auto name = obj.getName();
		orignamelist.push_back(name);
	}
*/	bool result = TRUE;
	for (int i = 0; i < matlist.size(); i++) {
		if (i >= namelist.size()) {
			// ͂ꂽOXgI
			break;
		}
		auto name = namelist[i];
		if (name.empty()) {
			// w̖O󂾂疳ăXLbv
			continue;
		}
		auto mat = doc.getMaterial(matlist[i]);
		while (findMaterial(doc, name, matlist[i]) >= 0) {
			name = incrementNameNumber(name);
		}
		doc.setMaterialName(mat, name);
	}
	return result;
}

// Iގindex̃Xg擾
std::vector<cmq::mindex_t> CopyNames::getSelectedMaterials(cmq::CMQDocument &doc)
{
	std::vector<cmq::mindex_t> list;
	cmq::mindex_t mcount = doc.getMaterialCount();
	for (cmq::mindex_t mindex = 0; mindex < mcount; mindex++) {
		MQMaterial mat = doc.getMaterial(mindex);
		if (!mat) {
			continue;
		}
		bool selected = doc.isSelectMaterial(mat);
		if (selected) {
			// IގXgɒǉ
			list.push_back(mindex);
		}
	}
	return list;
}

